<template>
    <v-row justify="space-around">
        <v-menu v-model="datePickerMenu" :close-on-content-click="false" :nudge-width="600" offset-y attach>
            <template v-slot:activator="{ on, attrs }">
                <v-text-field
                    v-model="formattedDate"
                    :label="label"
                    :rules="rules"
                    :readonly="true"
                    @click="openDatePicker"
                ></v-text-field>
            </template>

            <v-date-picker
                v-model="internalValue"
                hide-header
                color="primary"
                :max="props.max"
                @update:model-value="emitInput"
            ></v-date-picker>
        </v-menu>
    </v-row>
</template>

<script setup>
import { ref, computed, defineProps, defineEmits, onMounted } from "vue";
import { DateTimeHelper } from '@/helpers/DateTimeHelper';
const dateTimeHelper = new DateTimeHelper();

const datePickerMenu = ref(false);
const activatorProps = ref(false);

const emit = defineEmits(['update:modelValue']);
const props = defineProps({
    label: {
        type: String,
        default: '',
    },
    rules: {
        type: Object,
        default: {},
    },
    value: {
        type: String,
        default: null,
    },
    max: {
        type: String,
        default: '',
    },
    closeDelay: {
        type: Number,
        default: 1000,
    },
});

const internalValue = ref(
    props.value
        ? new Date(props.value).toISOString().split('T')[0]
        : new Date(dateTimeHelper.getMaximumEmployeeDateOfBirth())
);

const openDatePicker = () => {
    datePickerMenu.value = true;
};

const formattedDate = computed(() => {
    if (internalValue.value) {
        return dateTimeHelper.dayMonthYearFormat(internalValue.value.toString());
    }
    return null;
});

const emitInput = (newValue) => {
    internalValue.value = newValue;
    emit('update:modelValue', newValue);
};
</script>
